function result = NewEm(action1,action2,action3,action4)

global EMINST;

if (nargin < 1), action1='Start'; end;

debug = 4;
Ueberschrift='Sprachverarbeitungs Praktikum - EM Algorithmus';

% Befehlsberprfung
switch lower(action1)

% ------------------------------------------------------------------------------------------------
% ------------------------------------------- Start ----------------------------------------------
% ------------------------------------------------------------------------------------------------
case 'start'
    if (debug > 3) fprintf('Start\n'), end;
    fig = NewEm('Initfigure');
    NewEm('InitVars');
    NewEm('Show');
    result = fig;
    NewEm('Rnd');
    NewEm('Paint');

% ------------------------------------------------------------------------------------------------
% ------------------------------------------- Rnd ------------------------------------------------
% ------------------------------------------------------------------------------------------------
case 'rnd'
    Breite=20;
    if nargin < 4, DIM = 10; end;
    if nargin < 3, KlassenAnzahl = 30; end;
    if nargin < 2, AnzahlVektoren = 5*DIM; end;

    AnzahlVerteilungen = 10;
    %AnzahlVerteilungen = KlassenAnzahl;
    
    My = Breite*rand(KlassenAnzahl,DIM)-Breite/2;  
    C = ones(1,KlassenAnzahl) / KlassenAnzahl;
    Sigma = ones(KlassenAnzahl,DIM);
    TestVektoren = [];
    TestVektoren_Start = {};
    
    for i=1:AnzahlVerteilungen,
        My_Start(i,1:DIM)=round(2*rand(1,DIM)*Breite)-Breite;
        Sigma_Start(i,1:DIM)=round(rand(1,DIM)*5)+1;
        TestVektoren_Start{i} = Stichprobe(AnzahlVektoren,DIM,{My_Start(i,:),Sigma_Start(i,:)});
        TestVektoren = [TestVektoren;TestVektoren_Start{i}];
    end;
    
    AnzahlVektoren=size(TestVektoren,1);

    % Daten kopieren
    fig = EMINST.ActInstance;
    Data = get(fig,'UserData');
    Data.DIM=DIM;
    Data.KlassenAnzahl=KlassenAnzahl;
    Data.AnzahlVektoren=AnzahlVektoren;
    Data.My=My; Data.C=C; Data.Sigma=Sigma;
    Data.TestVektoren = TestVektoren;
    Data.TestVektoren_Start = TestVektoren_Start;
    Data.My_Start = My_Start; Data.Sigma_Start = Sigma_Start;
    set(fig,'UserData',Data);
    
% ------------------------------------------------------------------------------------------------
% ------------------------------------------- Setdata ----------------------------------------------
% ------------------------------------------------------------------------------------------------
case 'setdata'
    fig = EMINST.ActInstance;
    Data = get(fig,'UserData');
    if (debug > 1), fprintf('Setting %s to ',action2),action3,end;
    eval(['Data.',action2,'=action3;']);
    set(fig,'UserData',Data);
    
% ------------------------------------------------------------------------------------------------
% ------------------------------------------- Show ----------------------------------------------
% ------------------------------------------------------------------------------------------------
case 'show'
    fig = EMINST.ActInstance;
    set(fig,'visible','on');
    NewEm('Setdata','Anzeige',1)

% ------------------------------------------------------------------------------------------------
% ------------------------------------------- Hide ----------------------------------------------
% ------------------------------------------------------------------------------------------------
case 'hide'
    fig = EMINST.ActInstance;
    set(fig,'visible','off');
    NewEm('Setdata','Anzeige',0);

% ------------------------------------------------------------------------------------------------
% ------------------------------------------- Initfigure -----------------------------------------
% ------------------------------------------------------------------------------------------------     
case 'initfigure'
    if (debug > 3) fprintf('Init Figure\n'), end;
    %-----------------------------------------------
    ButtonHoehe = 0.1;
    RandInnen=1/20;
    
    %WavePosition = [0.5+RandInnen,0+RandInnen,

    
    
    
    Buttons = 5; ButtonHeight=0.05; ButtonWidth=0.7; ButtonSpacing=0.01; 
    ButtonString={'Step','Run','Reset','Ende','Dim'};
    ButtonStartX=1-(1-ButtonWidth)/2; ButtonStartY=1-ButtonHeight;     
    
    % Neue Figure erstellen
        fig = figure('Name',Ueberschrift, ...
	        'NumberTitle','off', ...
   	        'DoubleBuffer','on', ...
	        'Color','white','DeleteFcn','NewEm(''Delete'')',...
            'visible','off');
        
	   Data.Bild.VektorAxis = axes('Units','normalized', ...
	        'Position',[0.05,0.1+ButtonHeight,0.925,0.95-ButtonHeight-0.15]);
           
	  for i = 1 : Buttons,
	      Data.Bild.Button(i) = uicontrol('Style','push','Units','normalized',...
              'Position',[ButtonStartX-ButtonWidth/Buttons*i-ButtonSpacing*(i-1),...
                  ButtonStartY-0.02, ButtonWidth/Buttons, ButtonHeight],...
              'BackgroundColor',[0.70 0.70 0.70],'String',ButtonString{i},...
              'Callback',['NewEm(''',ButtonString{i},''')']);
      end;
      
		Data.Bild.SchrittText = uicontrol('Style','text','Units','normalized',...
	   'String','Schritt:     0','Position',[0.55,-0.025,0.25,0.1],'BackgroundColor',[1 1 1]);
	
		Data.Bild.DimText = uicontrol('Style','text','Units','normalized',...
	   'String','DimX = 1 DimY = 2','Position',[0.8,-0.025,0.2,0.1],'BackgroundColor',[1 1 1]);
	
		Data.Bild.Check = uicontrol('Style','check','String','Vektornummern anzeigen','Callback','newem(''SwitchVektor'')',...
	      					'Units','normalized','Position',[0.025,0.05,0.2,0.025]);
		Data.Bild.Klassen = uicontrol('Style','check','String','Klassenplot anzeigen','Callback','newem(''SwitchVektor'')',...
	      					'Units','normalized','Position',[0.3,0.05,0.2,0.025]);
	                                          
        
      % Aktuelle EM Instanz in die Instanzenliste eintragen
      if (isempty(EMINST)),
        EMINST.Instances=1;EMINST.InstHandles=[fig];
      else    
        EMINST.Instances=EMINST.Instances+1;
        EMINST.InstHandles=[EMINST.InstHandles,fig];
      end;
      EMINST.ActInstance=fig;
      
    Data.Bild.DimX = 1; Data.Bild.DimY = 2; 
    set(fig,'UserData',Data);
      
      
    S = get(0,'ScreenSize'); Breite=S(3); Hoehe = S(4);
    P=0.1;
    S = S + [Breite*P,Hoehe*P,-Breite*2*P,-Hoehe*2*P];
    set(fig,'position',S);
    
    NewEm('InitWave');
    
    result = fig;
% ------------------------------------------------------------------------------------------------
% ------------------------------------------- LoadWave -----------------------------------------
% ------------------------------------------------------------------------------------------------     
case 'initwave'
    if (debug > 3) fprintf('Init wave\n'), end;
    %-----------------------------------------------
    fig=EMINST.ActInstance;
    Data = get(fig,'UserData');
    pos = get(Data.Bild.VektorAxis,'position');
    Data.Bild.VAOffPosition = pos;
    pos(4) = pos(4) / 2;
    set(Data.Bild.VektorAxis,'position',pos+[0,-0.025,0,0]);
    Data.Bild.VAOnPosition = pos+[0,-0.025,0,0];
    
    pos(2)=pos(2)+pos(4); pos(3) = pos(3) / 2;
    Data.Bild.WaveAxis = axes('position',pos+[0,0.0125,-0.0125,-0.0125],'FontSize',8);
    pos(1) = pos(1) + pos(3);
    Data.Bild.KlassenPlotAxis = axes('position',pos+[0.025,0.0125,-0.0125,-0.0125],'fontsize',8);
    set(fig,'UserData',Data);

% ------------------------------------------------------------------------------------------------
% ------------------------------------------- Run     -----------------------------------------
% ------------------------------------------------------------------------------------------------     
case 'run'
    if (debug > 3) fprintf('Run !\n'), end;
    %-----------------------------------------------
    fig = EMINST.ActInstance;
    Data = get(fig,'UserData');
    
    while Data.Konvergenz == 0,
      NewEm('Step');
      drawnow
      Data = get(fig,'UserData');
    end;

    
    
% ------------------------------------------------------------------------------------------------
% ------------------------------------------- Switch Vektor---------------------------------------
% ------------------------------------------------------------------------------------------------     
case 'switchvektor'
    if (debug > 3) fprintf('Vektornummern anzeigen !\n'), end;
    %-----------------------------------------------
    fig = EMINST.ActInstance;
    Data = get(fig,'UserData');
    
    if ~get(Data.Bild.Klassen,'Value')
        set(Data.Bild.WaveAxis,'visible','off');
        set(Data.Bild.KlassenPlotAxis,'visible','off');
        set(Data.Bild.VektorAxis,'position',Data.Bild.VAOffPosition);
    else
        set(Data.Bild.WaveAxis,'visible','on');
        set(Data.Bild.KlassenPlotAxis,'visible','on');
        set(Data.Bild.VektorAxis,'position',Data.Bild.VAOnPosition);
    end;
        
    if get(Data.Bild.Check,'Value'),
        set(Data.Bild.VektorText,'visible','on');
    else
        set(Data.Bild.VektorText,'visible','off');        
    end;
% ------------------------------------------------------------------------------------------------
% ------------------------------------------- Update     -----------------------------------------
% ------------------------------------------------------------------------------------------------     
case 'update'
    if (debug > 3) fprintf('Updating Screen\n'), end;
    %-----------------------------------------------
    fig=EMINST.ActInstance;
    Data = get(fig,'UserData');
    
    % Klassenmittelpunkte zeichnen
    set(Data.Bild.Klassenmittelpunkte,'XData',Data.My(:,Data.Bild.DimX)');
    set(Data.Bild.Klassenmittelpunkte,'YData',Data.My(:,Data.Bild.DimY)');
    
    if (Data.Konvergenz),
        set(Data.Bild.SchrittText,'String',sprintf('Konvergenz nach Schritt %d',Data.Schritt));
    else
        set(Data.Bild.SchrittText,'String',sprintf('Schritt %d',Data.Schritt));
    end;
    
    set(Data.Bild.DimText,'String',sprintf('DimX: %2d DimY: %2d',Data.Bild.DimX,Data.Bild.DimY));

    for i = 1: Data.KlassenAnzahl
				h = sqrt(Data.Sigma(i,Data.Bild.DimX));
				b = sqrt(Data.Sigma(i,Data.Bild.DimY));
				if not(b*h  == 0),
				set(Data.Bild.Ellipse(i),'Position',[Data.My(i,Data.Bild.DimX)-h,Data.My(i,Data.Bild.DimY)-b, 2*h,2*b]);
                end;
     end;
        
    
    
% ------------------------------------------------------------------------------------------------
% ------------------------------------------- Step       -----------------------------------------
% ------------------------------------------------------------------------------------------------     
case 'step'
    if (debug > 3) fprintf('Step\n'), end;
    %-----------------------------------------------

    fig=EMINST.ActInstance;
    Data = get(fig,'UserData');
    
    if Data.Konvergenz == 1, return; end;
  
% Inverse Matrizen und Determinanten Berechnen ...
[X,Y] = find(Data.Sigma == 0);
if (length(X) > 0) Data.Sigma = ones(Data.KlassenAnzahl,Data.DIM); Data.My = Data.My + rand * 20 - 10; end;
    

Data.InvSigma = 1./Data.Sigma;
Data.DetSigma = prod(Data.Sigma,2);

Sigma_old = Data.Sigma;
My_old = Data.My;
C_old = Data.C;

%u = zeros(AnzahlVektoren,KlassenAnzahl);

TestV3 = repmat(reshape(Data.TestVektoren',[1,Data.DIM,Data.AnzahlVektoren]),[Data.KlassenAnzahl,1,1]);
TestMy3 = repmat(Data.My,[1,1,Data.AnzahlVektoren]);

XMM=TestV3-TestMy3;
XMMSq=XMM.^2;


exponent=shiftdim(-0.5*sum(XMMSq.*repmat(Data.InvSigma,[1,1,Data.AnzahlVektoren]),2),2)';
u=1/(2*pi)^(Data.DIM/2)*repmat(1./sqrt(Data.DetSigma'),[Data.AnzahlVektoren,1]).*exp(exponent');


CU=repmat(Data.C,[Data.AnzahlVektoren,1]).*u;
my_gamma_sum=sum(CU,2);

% Falls die Wahrscheinlichkeiten zu klein werden wird my_gamma = 0, darf aber nicht ....
% Korrigieren 
[X,Y]=find(my_gamma_sum == 0);
my_gamma_sum(X,Y) = 1E5*realmin;
% my_gammas berechnen
my_gamma=CU./repmat(my_gamma_sum,[1,Data.KlassenAnzahl]);
%=find(my_gamma==0)
Data.C=sum(my_gamma,1)/Data.AnzahlVektoren;

SumHelp=repmat(sum(my_gamma)',[1,Data.DIM]);
Data.My=sum(TestV3.*shiftdim(repmat(my_gamma,[1,1,Data.DIM]),1),3)./SumHelp;
Testmy_gamma3 = repmat(reshape(my_gamma',[Data.KlassenAnzahl,1,Data.AnzahlVektoren]),[1,Data.DIM,1]);
Data.Sigma=sum(XMMSq.*Testmy_gamma3,3)./SumHelp;

% Falls my_gamma == 0 wird muss ebenfalls wieder eine korrektur vorgenommen werden
% Die Kovarianzmatrix wird nicht gendert
%Help=find(SumHelp(:,1)<1E-3);
%Sigman(Help,1:DIM)=Sigma_old(Help,1:DIM);
  
  S1 = max(Data.Sigma-Sigma_old);
  S1 = S1(:);
  S2 = max(Data.My-My_old);
  S1 = [S1;S2(:)];
  S2 = max(Data.C-C_old);
  S1 = [S1;S2(:)];
  M = max(S1);
  if M < 1E-7, 
     Data.Konvergenz = 1; 
%     if (Anzeige == 1) set([Button(1) Button(2)],'Enable','off'); end;
  end;   
Data.Schritt = Data.Schritt + 1;  	
fprintf('Nach Schritt %d -> Fehler %d\n',Data.Schritt,M);

Count = Data.KlassenAnzahl;
C = []; Sigma = []; My = [];
for i = 1: Count,
    X = find(Data.Sigma(i,:) == 0);
    Y = find(Data.Sigma(i,:) > 1E7);
    if (length(X) == 0),
        My = [My; Data.My(i,:)];
        C = [C, Data.C(i)];
        Sigma = [Sigma; Data.Sigma(i,:)];
    else
        Data.KlassenAnzahl = Data.KlassenAnzahl-1;        
    end;
    
end;
Data.My = My;
Data.Sigma = Sigma;
Data.C = C;


[X,Y] = find(Data.Sigma > 1E10);
if (length(X) > 0) Data.Sigma = ones(Data.KlassenAnzahl,Data.DIM); Data.My = Data.My + rand * 20 - 10; end;

set(fig,'UserData',Data);

Newem('Update');
  
% ------------------------------------------------------------------------------------------------
% ------------------------------------------- Delete -------------------------------------------
% ------------------------------------------------------------------------------------------------      
  case 'delete'
    if (debug > 3), fprintf('Delete Instance\n'), end;
    %-----------------------------------------------
    EMINST.Instances=EMINST.Instances-1;
    if (debug > 2), fprintf('Deleting: %d\n',gcbf),end;
    Nr = find(EMINST.InstHandles == gcbf);
    Help = [EMINST.InstHandles(1:Nr-1)];
    if (EMINST.Instances>=Nr),Help=[Help,EMINST.InstHandles(Nr+1:EMINST.Instances+1)];end;
    EMINST.InstHandles=Help;
      
% ------------------------------------------------------------------------------------------------
% ------------------------------------------- InitVecs ------------------------------------------
% ------------------------------------------------------------------------------------------------
  case 'initvecs'
    if (debug > 3) fprintf('Init Vectors\n'), end;
    %-----------------------------------------------

% ------------------------------------------------------------------------------------------------
% ------------------------------------------- Paint ------------------------------------------
% ------------------------------------------------------------------------------------------------
  case 'paint'
    if (debug > 3) fprintf('Paint\n'), end;
    fig=EMINST.ActInstance;
    Data=get(fig,'UserData');
    
    DIMX = Data.Bild.DimX;
    DIMY = Data.Bild.DimY;
    
    if (Data.Anzeige),
        axes(Data.Bild.VektorAxis); cla;
        if (debug > 3) fprintf('Visible ! Plotting Vektors\n'), end;
        Data.Bild.Vektoren = plot(Data.TestVektoren(:,DIMX),Data.TestVektoren(:,DIMY),'ro');
        hold on;
        Data.Bild.Klassenmittelpunkte = plot(Data.My(:,DIMX),Data.My(:,DIMY),'bx');
        % Nummern erzeugen
        Nr=floor(log10(Data.AnzahlVektoren))+2;
        Kommando=['S(i,:)=sprintf(''%',sprintf('%d',Nr),'d'',i);'];
        for i=1:Data.AnzahlVektoren,
            eval(Kommando); 
        end;
        Data.Bild.VektorText = text(Data.TestVektoren(:,1),Data.TestVektoren(:,2),S,'FontSize',6,'Visible','off');

        
        for i = 1: Data.KlassenAnzahl
				h = sqrt(Data.Sigma(i,Data.Bild.DimX));
				b = sqrt(Data.Sigma(i,Data.Bild.DimY));
				if not(b*h  == 0),
				Data.Bild.Ellipse(i) = rectangle('Curvature',[1 1],'Position',[Data.My(i,Data.Bild.DimX)-h,Data.My(i,Data.Bild.DimY)-b, 2*h,2*b]);
                end;
        end;
        
        
        set(fig,'UserData',Data);
    end;
    
    % Falls ntig Vektornummern verstecken
    NewEm('SwitchVektor');
    
    
    %-----------------------------------------------
    
% ------------------------------------------------------------------------------------------------
% ------------------------------------------- Initvars ------------------------------------------
% ------------------------------------------------------------------------------------------------
case 'initvars'
    if (debug > 3) fprintf('Init Variables\n'), end;
    %-----------------------------------------------
    fig = EMINST.ActInstance;
    Data = get(fig,'UserData');
    Data.Schritt = 1;
    Data.Konvergenz = 0;
    Data.DIM = 1;
    Data.AnzahlVektoren = 0;
    Data.KlassenAnzahl = 0;
    
    
    set(fig,'UserData',Data);
    
    
% ------------------------------------------------------------------------------------------------
% ------------------------------------------- Otherwise ----------------------------------------------
% ------------------------------------------------------------------------------------------------
otherwise        
    if (debug > 3) fprintf('Kein Userbefehl\n'), end;
    %-----------------------------------------------
end;

    