function [Res1,Res2,Res3] = em(action,action2,action3);

% Globale Bildvariablen
persistent Bild Anzeige DimXText DimYText Check SchrittText Button 

persistent Schritt Konvergenz KlassenAnzahl AnzahlVektoren DIM DimX DimY

persistent TestVektoren My_Start Scale_Start My Sigma C C_Start GewinnerKlasse

persistent Dateiname OldSelectedVector WaveFile KlassenPlot

% ------------------- Konstanten ------------------
  Buttons = 5;
  ButtonHeight=0.05;
  ButtonWidth=0.7;
  ButtonSpacing=0.01;
  ButtonString={'Step','Run','Reset','Ende','Dim'};
  ButtonStartX=1-(1-ButtonWidth)/2;
  ButtonStartY=1-ButtonHeight;  
  Res1 = []; Res2 = []; Res3 = {};
  
  if and(nargin > 0, nargin < 3), action3 = 10; end;  
  if nargin < 2, action2 = ''; end;

if nargin > 0,
	if strcmp(action,'Reset')	% Alle Variablen lschen ....   
	     if (Bild > 0) close(Bild); end;
	     clear;
	     em('Init');
	     
	elseif strcmp(action,'Result')
	        Res1 = TestVektoren;
	        Res2 = {C,My, Sigma};
           Res3 = {C_Start, My_Start, sqrt(Scale_Start)};
	        
   elseif strcmp(action,'Init')
           
		if (Bild > 0) close; end;
	   Anzeige = 0; 
	   Bild = -1;
	   
		DimX = 1; DimY = 2;   
	   Schritt = 0;
	   Konvergenz = 0;
	   DIM = 2;
		GewinnerKlasse = [];	     
   	KlassenAnzahl = action3;     

	
	elseif strcmp(action,'Rnd')
%      AnzahlVektoren = 50;
      AnzahlVektoren = 200;
      AnzahlVerteilung = 3;
      KlassenAnzahl = 3;
      if isempty(KlassenAnzahl), KlassenAnzahl = AnzahlVerteilung; end;
%      if nargin > 1, if double(action2), AnzahlVerteilung = action2; end;end;
      DIM = 5;
%      DIM = 32;
      
      My = 8*rand(KlassenAnzahl,DIM)-4;

		C = ones(1,KlassenAnzahl) / KlassenAnzahl;
      C_Start = ones(1,AnzahlVerteilung) / AnzahlVerteilung;
      
      Sigma = [];
		Sigma = ones(KlassenAnzahl,DIM);
      
		My_Start = round(8*rand(AnzahlVerteilung, DIM)-4);
		My = round(8*rand(KlassenAnzahl, DIM)-4);
	
		Scale_Start =1./(round(3*rand(AnzahlVerteilung,DIM))+1);
		%Scale =1./(round(3*rand(KlassenAnzahl,DIM))+1);
	
		% Testvektoren produzieren
		TestVektoren = [];
	   for i = 1:AnzahlVerteilung
	      for vec = 1:AnzahlVektoren
	         VHelp = randn(1,DIM).*Scale_Start(i,:)+My_Start(i,:);
	         TestVektoren = [TestVektoren;VHelp];
	      end;
	   end;
		AnzahlVektoren = AnzahlVektoren * AnzahlVerteilung;  

	elseif strcmp(action,'Initfigure')
	   Anzeige = 1;
	   Bild = figure('Name','Sprachverarbeitungs Praktikum - EM Algorithmus', ...
	   'NumberTitle','off', ...
   	'DoubleBuffer','on', ...
	   'Color','white', ...
	   'BackingStore','off');
	      axes( ...
	   'Units','normalized', ...
	   'Position',[0.05,0.1+ButtonHeight,0.90-ButtonHeight,0.95-ButtonHeight-0.15]);
	   for i = 1 : Buttons,
	      Button(i) = uicontrol('Style','push','Units','normalized',...
	   'Position',[ButtonStartX-ButtonWidth/Buttons*i-ButtonSpacing*(i-1),ButtonStartY-0.02, ButtonWidth/Buttons, ButtonHeight],...
	   'BackgroundColor',[0.70 0.70 0.70],'String',ButtonString{i},...
	   'Callback',['em(''',ButtonString{i},''')']      );
		end;
		SchrittText = uicontrol('Style','text','Units','normalized',...
	   'String','','Position',[0.45,0,0.1,0.1],'BackgroundColor',[1 1 1]);
	
		DimXText = uicontrol('Style','text','Units','normalized',...
	   'String','','Position',[0.9,0,0.1,0.1],'BackgroundColor',[1 1 1]);
	
		DimYText = uicontrol('Style','text','Units','normalized',...
	   'String','','Position',[0.9,0,0.1,0.05],'BackgroundColor',[1 1 1]);
	
		Check = uicontrol('Style','check','String','Vektornummern anzeigen','Callback','em(''Paint'')',...
	      					'Position',[20 20 200 20]);
	                                    
	   set(Check,'Value',0);      
	   set([Button(1) Button(2)],'Enable','on');   
      
      set(gcf,'WindowButtonDownFcn','em(''ButtonDown'');');
   	set(gcf,'KeyPressFcn',...
      'em(''KeyPress'');');

	% ******************************** Dimensionen neu whlen **************************
	elseif strcmp(action,'Dim');
		DimX = str2double(inputdlg('Dimension whlen','Dimension fr X-Achse angeben:'));
	   DimY = str2double(inputdlg('Dimension whlen','Dimension fr Y-Achse angeben:'));
	   em('Paint');
   	
	elseif strcmp(action,'Paint')
	   if Anzeige == 1,
	   
	   	hold off;   
	   	BezeichnerC = GenStrCell([1:AnzahlVektoren],'%d');
   		Bezeichner=[0:AnzahlVektoren-1];

		   if get(Check,'Value'),
				[VX,VY] = VPaint(TestVektoren,'ro',DimX,DimY,BezeichnerC,7,+1,Bezeichner);
		   else 
		      [VX,VY] = VPaint(TestVektoren,'ro',DimX,DimY,GewinnerKlasse,9,-1,Bezeichner);
		   end;
		   
		   % ---------- Klassenmittelpunkte zeichnen und beschriften ----------------
		   BezeichnerC = GenStrCell([1:KlassenAnzahl],'K%d');
		   
		   [VX2,VY2] = VPaint(My,'bx',DimX,DimY,BezeichnerC,9);
         % ------------------------------------------------------------------------
         
         for i = 1: KlassenAnzahl
				h = sqrt(Sigma(i,DimX));
				b = sqrt(Sigma(i,DimY));
				if not(b*h  == 0),
				rectangle('Curvature',[1 1],'Position',[My(i,DimX)-h,My(i,DimY)-b, 2*h,2*b])
            end;
         end;
         
		   if Konvergenz == 0 
		      set(SchrittText,'String',sprintf('Schritt %d',Schritt));
		   else
		      set(SchrittText,'String',sprintf('Konvergenz nach Schritt %d',Schritt));
		   end;
		   
		   set(DimXText,'String',sprintf('Dim X: %d',DimX));
		   set(DimYText,'String',sprintf('Dim Y: %d',DimY));
			   
		   XMin = min([VX(1) VX2(1)]);
		   XMax = max([VX(2) VX2(2)]);
		   
		   YMin = min([VY(1) VY2(1)]);
		   YMax = max([VY(2) VY2(2)]);
   	
		   set (gca,'XLim',[XMin,XMax]);
		   set (gca,'YLim',[YMin,YMax]);   
		end;	   
      
   elseif strcmp(action,'ButtonDown')
   if exist('OldSelectedVector'), 
      a = findobj('Userdata',OldSelectedVector);
      set(a,'Color',[1 0 0]);
   end;
   x = [];  	
   x = get(gca,'CurrentPoint');
   if not(isempty(x)),
      
	   x = x(1,1:2);
	   x = ([ones(AnzahlVektoren,1) .* x(1),ones(AnzahlVektoren,1) .* x(2)] - ...
   	   [TestVektoren(:,DimX),TestVektoren(:,DimY)]);
      [x, Nr] = min([x(:,1).*x(:,1)+x(:,2).*x(:,2)]);

      if isempty(GewinnerKlasse), GewinnerKlasse = Klassifizieren(TestVektoren,{C,My,Sigma}); end;
      em('Paint');
      
	   a = findobj('UserData',Nr-1);
	   set(a,'Color',[0 1 0]);
      OldSelectedVector = Nr;
      
      if not(isempty((WaveFile))), 
         vecplot(Nr-1,20E-3,10E-3,WaveFile);
      end;

      
      HelpFig = gcf;
      if isempty(KlassenPlot),
          KlassenPlot = figure('Name','SV-Praktikum Klassenplot');
      end;
      figure(KlassenPlot);
      clf;
      
      if not(isempty(GewinnerKlasse)),
        plot(OldSelectedVector,GewinnerKlasse(OldSelectedVector),'bx');
      end;
      figure(HelpFig);
      
      if not(isempty((WaveFile))), 
         vecplot(Nr-1,20E-3,10E-3,WaveFile);
      end;
      
      
      
  end;
   
   
elseif strcmp(action,'KeyPress')
   x = get(Bild,'CurrentCharacter');
   if strcmp(x,'w'), 
      if not(isempty(OldSelectedVector)),
	   a = findobj('UserData',OldSelectedVector-1);
	   set(a,'Color',[1 0 0]);       
      OldSelectedVector = min(OldSelectedVector+1,AnzahlVektoren);
      a = findobj('UserData',OldSelectedVector-1);
	   set(a,'Color',[0 1 0]);
      if not(isempty(WaveFile)), 
         vecplot(OldSelectedVector-1,20E-3,10E-3,WaveFile);
      end;

      if not(isempty(KlassenPlot)),
        HelpFig = gcf;
        figure(KlassenPlot);
        hold on;
        
        if not(isempty(GewinnerKlasse)),
            plot([OldSelectedVector-1,OldSelectedVector],[GewinnerKlasse(OldSelectedVector-1),GewinnerKlasse(OldSelectedVector)],'bx');
            plot([OldSelectedVector-1,OldSelectedVector],[GewinnerKlasse(OldSelectedVector-1),GewinnerKlasse(OldSelectedVector)],'r-');
        end;
        hold off;
        figure(HelpFig);
      end;
      
      
  end;end;
      
elseif strcmp(action,'LoadWave'),
   if exist(action2),
      WaveFile = action2;
   end;
   
elseif strcmp(action,'Ende')
   if (Bild > 0) close; end;

      
% *******************************************************************************
% ************************************ EM Schritt *******************************
% *******************************************************************************

elseif strcmp(action,'Step')
   
if Konvergenz == 1, return; end;
   
InvSigma = zeros(KlassenAnzahl,DIM);
DetSigma = zeros(KlassenAnzahl,1);

% Inverse Matrizen und Determinanten Berechnen ...
for i = 1 : KlassenAnzahl
   for count = 1 : DIM
      if not(Sigma(i,count) == 0)
         InvSigma(i,count) = 1/Sigma(i,count);
      else
         InvSigma(i,count) = 1E2;
      end;
   end;
   DetSigma(i) = prod(Sigma(i,:));
end

Sigma_old = Sigma;
My_old = My;
C_old = C;

%u = zeros(AnzahlVektoren,KlassenAnzahl);

TestV3 = repmat(reshape(TestVektoren',[1,DIM,AnzahlVektoren]),[KlassenAnzahl,1,1]);
TestMy3 = repmat(My,[1,1,AnzahlVektoren]);

XMM=TestV3-TestMy3;
XMMSq=XMM.^2;


exponent=shiftdim(-0.5*sum(XMMSq.*repmat(InvSigma,[1,1,AnzahlVektoren]),2),2)';
u=1/(2*pi)^(DIM/2)*repmat(1./sqrt(DetSigma'),[AnzahlVektoren,1]).*exp(exponent');


CU=repmat(C,[AnzahlVektoren,1]).*u;
my_gamma_sum=sum(CU,2);

% Falls die Wahrscheinlichkeiten zu klein werden wird my_gamma = 0, darf aber nicht ....
% Korrigieren 
[X,Y]=find(my_gamma_sum == 0);
my_gamma_sum(X,Y) = 1E5*realmin;
% my_gammas berechnen
my_gamma=CU./repmat(my_gamma_sum,[1,KlassenAnzahl]);
%=find(my_gamma==0)
C=sum(my_gamma,1)/AnzahlVektoren;

SumHelp=repmat(sum(my_gamma)',[1,DIM]);
My=sum(TestV3.*shiftdim(repmat(my_gamma,[1,1,DIM]),1),3)./SumHelp;
Testmy_gamma3 = repmat(reshape(my_gamma',[KlassenAnzahl,1,AnzahlVektoren]),[1,DIM,1]);
Sigma=sum(XMMSq.*Testmy_gamma3,3)./SumHelp;

% Falls my_gamma == 0 wird muss ebenfalls wieder eine korrektur vorgenommen werden
% Die Kovarianzmatrix wird nicht gendert
%Help=find(SumHelp(:,1)<1E-3);
%Sigman(Help,1:DIM)=Sigma_old(Help,1:DIM);
  
  S1 = max(Sigma-Sigma_old);
  S1 = S1(:);
  S2 = max(My-My_old);
  S1 = [S1;S2(:)];
  S2 = max(C-C_old);
  S1 = [S1;S2(:)];
  M = max(S1);
  if M < 1E-5, 
     Konvergenz = 1; 
     if (Anzeige == 1) set([Button(1) Button(2)],'Enable','off'); end;
  end;   
Schritt = Schritt + 1;  	
%fprintf('Nach Schritt %d -> Fehler %d\n',Schritt,M);
em('Paint');
drawnow;


elseif strcmp(action,'Run')
   while Konvergenz == 0,
      em('Step');
   end;
   em('Paint');
   
elseif strcmp(action,'InitVecs')
    em('Init');
    
    if not(isempty(action2)),
        TestVektoren = action2;
        
        DIM = size(TestVektoren,2);
        AnzahlVektoren = size(TestVektoren,1);
        
        if isempty(action3),
            KlassenAnzahl = 10;
        else
            KlassenAnzahl = action3;
        end;

		C = ones(1,KlassenAnzahl) / KlassenAnzahl;
        C_Start = zeros(1,KlassenAnzahl);
      
          Sigma = [];
		Sigma = ones(KlassenAnzahl,DIM);
      
		My_Start = zeros(KlassenAnzahl,DIM);
		My = round(8*rand(KlassenAnzahl, DIM)-4);
    
    end;

else	% if strcmp(action, ...)
    if exist(action) > 0,
           em('Init','',action3);
          [TestVektoren,L] = readvec(action);
          
   else
      return;
   end;
   
   Dateiname = action;
   
   if L>0 
      DIM = L; 
      sprintf('Lade Datei %s !',Dateiname)
      AnzahlVektoren = size(TestVektoren,1);
                  
		C = ones(1,KlassenAnzahl) / KlassenAnzahl;
        C_Start = zeros(1,KlassenAnzahl);
      
          Sigma = [];
		Sigma = ones(KlassenAnzahl,DIM);
      
		My_Start = zeros(KlassenAnzahl,DIM);
		My = round(8*rand(KlassenAnzahl, DIM)-4);
      
      if and(nargin > 1, strcmp(action2,'Paint')),
         Anzeige = 1;
         em('Initfigure');
   	end; 
		
      em('Paint');		
   end;
end;

else  % if nargin > 0 
	em('Init');
	em('Initfigure');
    KlassenAnzahl = 2;
	em('Rnd');
	em('Paint');
end;

