function fl(Pri,M,Sig,DimX,DimY,X,Y)

persistent Bild;

Bild = figure;

if isempty(Bild), Bild = figure('Name','Klassifikationspraktikum - Klassenflchen'); end;


% ******************* Colormap berechnen ******************
%MAP = zeros(400,3);
%for i = 0:200,
%	z=(i*0.8/200)^0.8;
%	MAP(i+200,3)=1-z;
%	MAP(i+200,2)=1-z;
%	MAP(i+200,1)=1-z; 
%end
% Die 3 Grundfarben : Rot Grn Blau ... bleiben aber erhalten
%MAP(1,:) = [1 0 0];
%MAP(2,:) = [0 1 0];
%MAP(3,:) = [0 0 1];
%colormap(MAP);


% Das sind unsere Anfangsbedingungen 

if nargin < 5, DimX = 1; DimY = 2; end;

if nargin < 3,	
   Anzahl = 3;				% 3 Verteilungen 
	Sigma = cat(3,[1 0.5;0.5 2],[2 -1;-1 1],[2 0;0 2])*2;		% Jede mit einer Kovarianzmatrix
	My = cat(3,[2;2],[-2;2],[0;-2.5]) / 2;							% und einem Mittelwert
   Priori = [0.33,0.33,0.33];											% und einer Prioriwahrscheinlichkeit
else   
   Anzahl = length(Pri);
   Sigma = [];
   My = [];
   
   for i = 1: Anzahl,
      Sigma=cat(3,Sigma,diag([Sig(i,DimX),Sig(i,DimY)]));
      My = cat(3,My,[M(i,DimX);M(i,DimY)]);
      Priori = Pri';
   end;
end;
      
if nargin < 7
% Das ist der zu berechnende Bereich
	X=[-7:.1:7];
   Y=[-7:.1:7];
end;
   

SigmaInv = [];

% Vorberechnungen ! Determinanten und Inverse der Kovarianzmatrizen
for i=1:Anzahl
   SigmaInv = cat(3,SigmaInv,inv(Sigma(:,:,i)));
   SigmaDet(i) = det(Sigma(:,:,i));
end


% Ein paar Konstanten fr die Nebenrechnung ....
exponent = [];
Farbe = [1:Anzahl];
Col = [];

for x=1:length(X)
   for y=1:length(Y)
      % r2 = unser aktueler Ortsvektor (x,y)
      r2 = [X(x);Y(y)];
      
      for kl=1 : Anzahl		% Fr jede Verteilung den Exponenten, Gamma und den Funktionswert berechnen
         r1 = r2 - My(:,:,kl);
         gamma(x,y,kl) = Priori(kl) / (sqrt(2*pi)^2*sqrt(SigmaDet(i)));
         exponent(x,y,kl) = -0.5 *r1'*SigmaInv(:,:,kl)*r1;         
         z(x,y,kl) = gamma(x,y,kl) * exp(exponent(x,y,kl));
      end;
      
      % Das ist unser Prfgrenvektor
      Vektor(1:Anzahl) = log(gamma(x,y,1:Anzahl))+exponent(x,y,1:Anzahl);
      
      % Schwupps ! Das Maximum bestimmt (weil negativ das maximum !)
      [min,Nr] = max(Vektor);
      
      Col(x,y) = Farbe(Nr);	% Fr jede Klasse eine Farbe ...
      S(x,y) = max(z(x,y,1:Anzahl));	% Der grte Funktionswert wird angezeigt
%      pause
   end;
end;

max(S)

% So ! Die Klassifikationsflche gemalt !
hold on;
surf(X,Y,zeros(length(X),length(Y)),Col,'EdgeColor','none');
%colormap('default');



M = meshgrid(X,Y);
% Die Funktion malen !
%colormap(MAP);
su = surf(X,Y,0.2*S/max(max(S))+0.2);

% Und schn als gerenderten Patch aufarbeiten ...
pa = patch(surf2patch(su));
delete(su);
shading interp;
lighting gouraud; 
camlight headlight;
lightangle(0,50);
hold off;
view(3);